=== debian/changelog ===
ros-ros-comm (1.17.0+ds-2) unstable; urgency=medium

  * Migrate to dh-ros

 -- Timo Röhling <roehling@debian.org>  Sat, 05 Oct 2024 01:12:35 +0200

ros-ros-comm (1.17.0+ds-1) unstable; urgency=medium

  * New upstream version 1.17.0+ds
  * Update patches
    - Drop 0008-Update-bind.hpp-location.patch (obsolete)
  * Wrap and sort Debian package files
  * Install new rosnode binary

 -- Timo Röhling <roehling@debian.org>  Mon, 30 Sep 2024 22:43:11 +0200

ros-ros-comm (1.16.0+ds-6) unstable; urgency=medium

  * Revert wrong assert_ replaces.
    Thanks to Lucas Walter
  * Disable XmlRpcServer::enoughFreeFDs
  * Bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 20 Jun 2024 10:44:22 +0200

ros-ros-comm (1.16.0+ds-5) unstable; urgency=medium

  * Stop recommending python3-crypto (no longer used) (Closes: #1072358)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 01 Jun 2024 16:01:16 +0200

ros-ros-comm (1.16.0+ds-4) unstable; urgency=medium

  [ Matthias Klose ]
  * Fixes for Python 3.12 (Closes: #1066946)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 17 Mar 2024 09:58:40 +0100

ros-ros-comm (1.16.0+ds-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062868

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 15:26:41 +0000

ros-ros-comm (1.16.0+ds-3) unstable; urgency=medium

  * Add assert_ to RosTest (Closes: #1056039)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 20 Nov 2023 12:29:26 +0100

ros-ros-comm (1.16.0+ds-2) unstable; urgency=medium

  * Update header for Boost 1.83 (Closes: #1056012)
  * Add missing make dependency to autopkgtest

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 16 Nov 2023 10:20:31 +0100
