=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export ROS_PYTHON_EXTENSION_PACKAGES = roslz4
export ROS_CONFIGURE_ARGS = -DPYVER={python_version}
export ROS_SKIP_TESTS = rostest topic_tools
export ROS_IGNORE_TEST_RESULTS = $(if $(filter amd64,$(DEB_HOST_ARCH)),,1)
export ROS_SKIP_PACKAGES = ros_comm \
	test_rosbag test_rosbag_storage test_roscpp test_rosgraph \
	test_roslaunch test_roslib_comm test_rosmaster test_rosparam \
	test_rospy test_rosservice test_rostest test_rostopic

%:
	dh $@ --buildsystem=ros
