=== debian/changelog ===
ros-ros-comm (1.17.4+ds-3) unstable; urgency=medium

  * Invert ROS_SKIP_TESTS logic

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Sep 2025 15:09:27 +0200

ros-ros-comm (1.17.4+ds-2) unstable; urgency=medium

  * Work around hanging tests on armhf/armel

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Sep 2025 12:28:39 +0200

ros-ros-comm (1.17.4+ds-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 1.17.4+ds
  * Update patches.
    Obsolete: 0014-Update-header-for-Boost-1.83.patch
    Obsolete: 0015-rosgraph-update-code-from-Python-3.11.patch
    Merged: 0016-Fixes-for-Python-3.12.patch
    Merged: 0017-Disable-XmlRpcServer-enoughFreeFDs.patch
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.2
  * Fix Python SyntaxWarning (Closes: #1087065)

 -- Timo Röhling <roehling@debian.org>  Tue, 09 Sep 2025 22:24:21 +0200
